// VinciaBranchelemental.cc is a part of the VINCIA plug-in to the PYTHIA 8 generator.
// Copyright (C) 2014 P. Skands.
// VINCIA is licenced under the GNU GPL version 2.
// Please respect the MCnet Guidelines for Event Generator Authors and Users, 
//               http://www.montecarlonet.org/GUIDELINES

// Function definitions for the Branchelemental class.

#include "VinciaBranchelemental.h"

namespace Vincia {

//**********************************************************************

// Branchelemental class member functions

//*********
// Simple print utility, showing the contents of the Branchelemental

void Branchelemental::list(ostream& os, bool header, bool footer) const { 
  if (header) {
    // Header.
    os << "\n --------  VINCIA Dipole-Antenna Listing  ------------------------------"
       << "------------------------------------------------------------ \n \n" 
       << "  sys       antenna type   pols    col    L aunts   parents  R uncles"
       << "         m  Ord  Saved Trial Swap    Qtrial "
       << " nVeto nHull nHadr\n"
       << fixed << setprecision(3);
  }
  os << setw(5) << system<<" ";
  os << setw(9) << old1.name();
  os << setw(9) << old2.name()<<"  ";
  os << setw(2) << int(old1.pol()) <<" "<<setw(2)<< int(old2.pol())<<" ";
  os << setw(6) << old1.col()<<" ";
  os << setw(5) << iLL << setw(5) << iL;
  os << setw(5) << iOld1 << setw(5) << iOld2;
  os << setw(5) << iR << setw(5) << iRR;
  os << num2str(m(),10);
  os << setw(5) << (unOrdering ? "n" : "y");
  int iWin = getTrialIndex();
  if (nTrialGenerators() >= 1 && iWin >= 0) {
    if (hasSavedTrial[iWin]) {
      os<< setw(13)<< trialGenPtrSav[iWin]->name();
      os << setw(5) << (isSwappedSav[iWin] ? "y" : "n");
      os<< num2str(scaleSav[iWin],10);
    }
  } else {
    os<<setw(13)<<"-";
    os<<setw(15)<<" ";
  }
  os << " "<<setw(6)<<nVeto;   
  os << " "<<setw(5)<<nHull;   
  os << " "<<setw(5)<<nHadr;   
  os << endl;   
  if (footer) {
    os << "\n --------  End VINCIA VinciaShower Dipole-Antenna Listing  ------------"
       << "-------------------------------------------------------------\n";
  }
}
  
}
