# Script to process validation data files in directories and assign 
# labels to them reflecting the tune name (first-letter uppercase of 
# directory names). 

#!/bin/sh
DIRS=`ls -l | egrep '^d' | awk '{print $9}'`

# "ls -l $MYDIR"      = get a directory listing
# "| egrep '^d'"           = pipe to egrep and select only the directories
# "awk '{print $8}'" = pipe the result from egrep to awk and print only the 8th field

# and now loop through the directories:
for DIR in $DIRS
do
  SRC=`echo ${DIR:0:1} | tr  '[a-z]' '[A-Z]'`${DIR:1}
  SRC=`echo ${SRC} | sed s/-/" "/`
  echo Processing Tune ${SRC}
  FILES=`ls -l $DIR | egrep 'dat' | awk '{print $9}'`
  cd $DIR 
  for FILE in $FILES
  do
    if [ -r ${FILE} ]; then
# Change the line with SRC to 
      cat ${FILE} | sed "s/SRC.*/SRC = ${SRC}/" > tmp.out
      chmod 666 $FILE
      mv tmp.out $FILE
      chmod 444 $FILE
    fi
  done
  cd ../
done

